/*****************************************************************************
 * Copyright (c) 2006-2007, Cloudsmith Inc.
 * The code, documentation and other materials contained herein have been
 * licensed under the Eclipse Public License - v 1.0 by the copyright holder
 * listed above, as the Initial Contributor under such license. The text of
 * such license is available at www.eclipse.org.
 *****************************************************************************/
package org.eclipse.buckminster.core.cspec.parser;

import org.eclipse.buckminster.core.cspec.SaxablePath;
import org.eclipse.buckminster.core.parser.ExtensionAwareHandler;
import org.eclipse.buckminster.sax.AbstractHandler;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

/**
 * @author Thomas Hallgren
 */
class PathHandler extends ExtensionAwareHandler
{
	public static final String TAG = SaxablePath.TAG;

	private IPath m_path;

	PathHandler(AbstractHandler parent)
	{
		super(parent);
	}

	final IPath getPath()
	{
		return m_path;
	}

	@Override
	public void handleAttributes(Attributes attrs) throws SAXException
	{
		m_path = Path.fromPortableString(this.getStringValue(attrs, SaxablePath.ATTR_PATH));
	}
}
